using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductTag;
namespace CMSMicroservice.Protobuf.Validator.ProductTag;

public class CreateNewProductTagRequestValidator : AbstractValidator<CreateNewProductTagRequest>
{
    public CreateNewProductTagRequestValidator()
    {
        RuleFor(model => model.ProductId)
            .NotNull();
        RuleFor(model => model.TagId)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewProductTagRequest>.CreateWithOptions((CreateNewProductTagRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
